import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This class represents a Bulbasaur.
 * <br /><br />
 * Esta classe representa um Bulbasaur.
 * 
 * @author Marcelo Schmitt 
 * @version 1.1 - 19/01/2014
 */
public class Bulbasaur extends Pokemon
{
    public Bulbasaur(){
        super("Bulbasaur", PokemonType.GRASS, 5, PokemonType.FIRE, PokemonType.NONE, 1);
        super.setConditionsClear();
    }
    
    //Bulbasaur's attack:
    /**
     * Requires: 1 colorless energy. Damage 1.
     * 
     * @param target
     *          the target pokemon
     */
    @Attack(name = "Ram", description = "Does 1 damage.", range = 1, rangeType = RangeType.MELEE)
    public void ram(Pokemon target) throws Exception{
        if(getOwner() != target.getOwner()){
            target.setDamageTaken(1, this.getType());
            setMoveAble(false);
            setAttackAble(false);
        } else{
            Greenfoot.playSound("Pokemon program error.wav");
            throw new Exception("Cannot attack a team mate pokemon!");
        }
    }
    /**
     * Requires: 2 grass energy. Damage 2. Heals 1 damage.
     * Unless all damage from this attack is prevented, you may remove 1 damage counter from Bulbasaur.
     * 
     * @param target
     *          the target pokemon
     */
    @Attack(name = "Leech Seed", description = "Does 2 damage. Heals 1 damage from Bulbasaur.", range = 4, rangeType = RangeType.RANGED)
    public void leechSeed(Pokemon target) throws Exception{
        if(getOwner() != target.getOwner()){
            target.setDamageTaken(2, this.getType());
            //TODO Bulbasaur se cura mesmo quando o dano é prevenido. Ex.: atacar um Squirtle que usou o ataque withdraw.
            setDamageHealed(1);
            setMoveAble(false);
            setAttackAble(false);
        } else{
            Greenfoot.playSound("Pokemon program error.wav");
            throw new Exception("Cannot attack a team mate pokemon!");
        }
    }
    
    /**
     * Act - do whatever the Bulbasaur wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    
}
