import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This class represents a Charmander.
 * <br /><br />
 * Esta classe representa um Charmander.
 * 
 * @author Marcelo Schmitt
 * @version 1.1 - 19/01/2014
 */
public class Charmander extends Pokemon
{
    public Charmander(){
        super("Charmander", PokemonType.FIRE, 5, PokemonType.WATER, PokemonType.NONE, 1);
        super.setConditionsClear();
    }
    
    //Charmander's attacks:
    /**
     * Requires: 1 fire energy. Damage 1.
     * 
     * @param target
     *          the target pokemon
     */
    @Attack(name = "Scratch", description = "Does 1 damage.", range = 1, rangeType = RangeType.MELEE)
    public void scratch(Pokemon target) throws Exception{
        if(getOwner() != target.getOwner()){
            target.setDamageTaken(1, this.getType());
            setMoveAble(false);
            setAttackAble(false);
        } else{
            Greenfoot.playSound("Pokemon program error.wav");
            throw new Exception("Cannot attack a team mate pokemon!");
        }
    }
    /**
     * Requires: 1 fire and 1 incolor energy. Damage 3.
     * Discart 1 fire Energy card attached to Charmander in order to use this attack.
     * 
     * @param target
     *          the target pokemon
     */
    @Attack(name = "Ember", description = "Does 3 damage.", range = 3, rangeType = RangeType.RANGED)
    public void ember(Pokemon target) throws Exception{
        if(getOwner() != target.getOwner()){
            target.setDamageTaken(3, this.getType());
            setMoveAble(false);
            setAttackAble(false);
        } else{
            Greenfoot.playSound("Pokemon program error.wav");
            throw new Exception("Cannot attack a team mate pokemon!");
        }
    }
    
    /**
     * Act - do whatever the Charmander wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    
}
