import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This class represents a Geodude.
 * <br /><br />
 * Esta classe representa um Geodude.
 * 
 * @author Marcelo Schmitt 
 * @version 1.1 - 19/01/2014
 */
public class Geodude extends Pokemon
{
    public Geodude(){
        super("Geodude", PokemonType.FIGHTING, 5, PokemonType.GRASS, PokemonType.LIGHTNING, 1);
        super.setConditionsClear();
    }
    
    //Geodude's attacks:
    /**
     * Requires: 1 fighting energy. Damage 1.
     * 
     * @param target
     *          the target pokemon
     */
    @Attack(name = "Rock Hurl", description = "Does 1 damage.", range = 2, rangeType = RangeType.RANGED)
    public void rockHurl(Pokemon target) throws Exception{
        if(getOwner() != target.getOwner()){
            target.setDamageTaken(1, this.getType());
            setMoveAble(false);
            setAttackAble(false);
        } else{
            Greenfoot.playSound("Pokemon program error.wav");
            throw new Exception("Cannot attack a team mate pokemon!");
        }
    }
    /**
     * Requires: 1 fighting and 1 incolor energy. Damage 0 to 'infinity' (5 here).
     * Flip a coin until you get tails. This attack does 10 damdage times the number of heads.
     * 
     * @param target
     *          the target pokemon
     */
    @Attack(name = "Stone Barrage", description = "Does a random damage from 0 to 5.", range = 3, rangeType = RangeType.RANGED)
    public void stoneBarrage(Pokemon target) throws Exception{
        if(getOwner() != target.getOwner()){
            target.setDamageTaken(Greenfoot.getRandomNumber(6), this.getType());
            /*
            int damageAmount = 0;
            while(PokeChessBoard.flipCoin()){
                damageAmount += 1;
            }
            target.setDamageTaken(damageAmount, this.getType());
            */
            setMoveAble(false);
            setAttackAble(false);
        } else{
            Greenfoot.playSound("Pokemon program error.wav");
            throw new Exception("Cannot attack a team mate pokemon!");
        }
    }
    
    /**
     * Act - do whatever the Geodude wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    
}
