import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

/**
 * Class that represents the buttons at the main menu.
 * <br /><br />
 * Classe que representa os botões do menu principal.
 * 
 * @author Marcelo Schmitt 
 * @version 1.1
 */
public class MenuButton extends Actor
{
    /**
     * Creates a new Actor which has a GreenfootImage with the buttonName printed in font 50.0 
     * whithin the specified width and height.
     * <br /><br />
     * Cria um ator que possui uma GreenfootImage para mostrar o buttonName com fonte 50.0 dentro de 
     * um retângulo de medidas width (largura) e height (altura).
     * 
     * @param buttonName
     *          the Sting to be displayed on the button
     * @param width
     *          the width of the button
     * @param height
     *          the height of the button
     */
    public MenuButton(String buttonName, int width, int height){
        //250, 75
        GreenfootImage button = new GreenfootImage(width, height);
        button.setColor(new Color(255, 255, 255, 100));
        button.fill();
        Font font = button.getFont();
        float fontSize = 50.0f;
        font = font.deriveFont(fontSize);
        button.setFont(font);
        button.setColor(Color.BLACK);
        button.drawString(buttonName, 75, 50);
        setImage(button);
    }
    
    /**
     * Act - do whatever the MenuButton wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    
}
