import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This class represents a Pikachu.
 * <br /><br />
 * Esta classe representa um Pikachu.
 * @author Marcelo Schmitt 
 * @version 1.1 - 19/01/2014
 */
public class Pikachu extends Pokemon
{
    public Pikachu(){
        super("Pikachu", PokemonType.LIGHTNING, 5, PokemonType.FIGHTING, PokemonType.NONE, 1);
        super.setConditionsClear();
    }
    
    //Pikachu's attacks:
    /**
     * Requires: 1 incolor energy. Damage 1.
     * 
     * @param target
     *          the target pokemon
     */
    @Attack(name = "Gnaw", description = "Does 1 damage.", range = 1, rangeType = RangeType.MELEE)
    public void gnaw(Pokemon target) throws Exception{
        if(getOwner() != target.getOwner()){
            target.setDamageTaken(1, this.getType());
            setMoveAble(false);
            setAttackAble(false);
        } else{
            Greenfoot.playSound("Pokemon program error.wav");
            throw new Exception("Cannot attack a team mate pokemon!");
        }
    }
    /**
     * Requires: 1 electric and 1 incolor energy. Damage 3.
     * Flip a coin. If tails, Pikachu does 10 damage to itself.
     * 
     * @param target
     *          the target pokemon
     */    
    @Attack(name = "Thundershock", description = "Does 3 damage but has a 50% chance do deal 1 damage to itself.", range = 3, rangeType = RangeType.BY_AREA)
    public void thundershock(Pokemon target) throws Exception{
        if(getOwner() != target.getOwner()){
            target.setDamageTaken(3, this.getType());
            if(!PokeChessBoard.flipCoin()){
                //Coroa
                this.setDamageTaken(1, null);
            }
            setMoveAble(false);
            setAttackAble(false);
        } else{
            Greenfoot.playSound("Pokemon program error.wav");
            throw new Exception("Cannot attack a team mate pokemon!");
        }
    }
    
    /**
     * Act - do whatever the Pikachu wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    
}
