import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This class represents a Squirtle.
 * <br /><br />
 * Esta classe representa um Squirtle
 * 
 * @author Marcelo Schmitt 
 * @version 1.1 - 19/01/2014
 */
public class Squirtle extends Pokemon
{
    public Squirtle(){
        super("Squirtle", PokemonType.WATER, 5, PokemonType.LIGHTNING, PokemonType.NONE, 1);
        super.setConditionsClear();
    }
    
    //Squirtle's attacks:
    /**
     * Requires: 1 water energy. Damage 1.
     * Flip a coin. If heads, the Defending Pokémon is now Paralyzed.
     * 
     * @param target
     *          the target pokemon
     */
    @Attack(name = "Bubble", description = "Does 1 damage. Has a 50% chance to paralyze the target pokemon.", range = 2, rangeType = RangeType.RANGED)
    public void bubble(Pokemon target) throws Exception{
        if(getOwner() != target.getOwner()){
            target.setDamageTaken(1, this.getType());
            if(!target.isParalyzed()){
                target.setParalyzed(PokeChessBoard.flipCoin());
            }
            setMoveAble(false);
            setAttackAble(false);
        } else{
            Greenfoot.playSound("Pokemon program error.wav");
            throw new Exception("Cannot attack a team mate pokemon!");
        }
    }
    /**
     * Requires: 1 water and 1 incolor energy. Damage 0.
     * Flip a coin. If heads, prevent all damage done to Squirtle during
     * your opponent's next turn. (Any other effects of attacks still 
     * happen.)
     * 
     * @param target
     *          the target pokemon
     */
    @Attack(name = "Withdraw", description = "Has a 50% chance to prevent all damage done to Squirtle during your opponent's next turn." +
                            "\n Any other effects of attacks still happen.", range = 0, rangeType = RangeType.SELF)
    //TODO mudar o RangeType de SELF para NONE e eliminar a necessidade do parâmetro target.
    public void withdraw(Pokemon target) throws Exception{
        setDamageImmune(PokeChessBoard.flipCoin());
        setMoveAble(false);
        setAttackAble(false);
    }
    
    /**
     * Act - do whatever the Squirtle wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    
}
